#include "conio2.h"
#include "amsgraph.h"
#include <stdio.h>

unsigned char glob_color = 0;
unsigned char char1,char2,char3,char4;

unsigned int GetTime()
{
	unsigned int nTime = 0;

	__asm
		CALL #0xBD0D ;KL TIME PLEASE
		PUSH HL
		POP DE
		LD HL, #_char3
		LD (HL), D
		LD HL, #_char4
		LD (HL), E
	__endasm;

	nTime = (char3 << 8) + char4;

	return nTime;
}


void PutPixelMode1(int nX, unsigned char nY, unsigned char nColor)
{
int nPixel = nX % 4;
unsigned char *pAddress = (unsigned char *)((unsigned int)(0xC000 + ((nY / 8) * 80) + ((nY % 8) * 2048) + (nX / 4)));

if(nPixel == 0)
{
*pAddress &= 119;

if(nColor & 1)
*pAddress |= 128;
if(nColor & 2)
*pAddress |= 8;
}
else if(nPixel == 1)
{
*pAddress &= 187;

if(nColor & 1)
*pAddress |= 64;
if(nColor & 2)
*pAddress |= 4;
}
else if(nPixel == 2)
{
*pAddress &= 221;

if(nColor & 1)
*pAddress |= 32;
if(nColor & 2)
*pAddress |= 2;
}
else //nPixel == 3
{
*pAddress &= 238;

if(nColor & 1)
*pAddress |= 16;
if(nColor & 2)
*pAddress |= 1;
}
}

void gpenMode1(unsigned char nColor) {
switch ( nColor % 4 )
	{
		case 0:
			glob_color = 0;
			break;
		case 1:
			glob_color = 240;  // 0xF0
			break;
		case 2:
			glob_color = 15;  // 0x0F
			break;
		case 3:
			glob_color = 255;  // 0xFF
			break;
	}
}

void PutPixelFastMode1(unsigned int nX, unsigned char nY)
{
// Input: DE = X (0..319), HL = Y (0..199) 

__asm

	; on rcupre les paramtres
	LD E, 4(IX)
	LD D, 5(IX)

	LD L, 6(IX)
	LD H, #0			; juste pour tre sur.

FPLOT:
	LD A, L			;A = octet bas de Y
	AND #0x7		;isole les Bit 0..2  (00000111)
	LD H, A			;= y MOD 8 vers H
	XOR L			;A = Bit 3..7 of Y
	LD L, A			;= (Y\8)*8 vers L
	LD C, A			;stock dans C
	LD B, #0x60		;B = &C0\2 = octet haut adresse de depart de l ecran \ 2
					; REMARQUE
					; si vous voulez dessiner dans un autre ecran que celui d'origine en C000 (par exemple 4000)
					; il faut changer cette valeur.
		
	ADD HL, HL		;HL * 2
	ADD HL, HL		;HL * 4
	ADD HL, BC		;+ BC = adresse de depart
	ADD HL, HL		;de la ligne de pixels
		
	LD A, E			;octet bas de X dans A
	SRL D			;calcule X\4, Car 
	RR E			;4 pixels par bit
	SRL E
	ADD HL, DE		;+ HL = adresse du pixel  modifier
		
	LD C, #0x88		;masque de bits pour le mode 1 (10001000)
	AND #3			;A = X MOD 4 (00000011)
	JR Z, NSHIFT	;-> = 0, aucun deplacement
SHIFT:
 	SRL C			;dplacer masque de pixel
	DEC A			;compteur de boucle
	JR NZ,SHIFT		;-position
		
NSHIFT:
	LD A,(#_glob_color); recupere le masque de couleur
					; REMARQUE
					; La couleur peut etre recupere en memoire a l'adresse B6A3 pour les 664 et 6128 et B338 pour le 464
					; moi j'ai prfr passer par un variable globale.
	XOR (HL)		;XOR octet du pixel
	AND C			;AND masque de pixel
	XOR (HL)		;XOR octet du pixel
	LD (HL), A		;nouveau octet du pixel
	
__endasm;
}



void lineBresenham(int x1,int y1,int x2,int y2, unsigned char nColor) {
int cx, cy,
ix, iy,
dx, dy,
ddx= x2-x1, ddy= y2-y1;

if (!ddx) { //vertical line special case
if (ddy > 0) {
cy= y1;
do PutPixelMode1(x1, cy++, nColor);
while (cy <= y2);
return;
} else {
cy= y2;
do PutPixelMode1(x1, cy++, nColor);
while (cy <= y1);
return;
}
}
if (!ddy) { //horizontal line special case
if (ddx > 0) {
cx= x1;
do PutPixelMode1(cx, y1, nColor);
while (++cx <= x2);
return;
} else {
cx= x2;
do PutPixelMode1(cx, y1, nColor);
while (++cx <= x1);
return;
}
}
if (ddy < 0) { iy= -1; ddy= -ddy; }//pointing up
else iy= 1;
if (ddx < 0) { ix= -1; ddx= -ddx; }//pointing left
else ix= 1;
dx= dy= ddx*ddy;
cy= y1, cx= x1;
if (ddx < ddy) { // < 45 degrees, a tall line
do {
dx-=ddy;
do {
PutPixelMode1(cx, cy, nColor);
cy+=iy, dy-=ddx;
} while (dy >=dx);
cx+=ix;
} while (dx > 0);
} else { // >= 45 degrees, a wide line
do {
dy-=ddx;
do {
PutPixelMode1(cx, cy, nColor);
cx+=ix, dx-=ddy;
} while (dx >=dy);
cy+=iy;
} while (dy > 0);
}
}

void Circle(int radius, int x_centre, int y_centre, unsigned char nColor) {
int x =0;
unsigned char y = radius;
int d = radius - 1;
while ( y >= x )
{
PutPixelMode1( x+x_centre, y+y_centre, nColor );
PutPixelMode1( y+x_centre, x+y_centre, nColor );
PutPixelMode1( -x+x_centre, y+y_centre, nColor );
PutPixelMode1( -y+x_centre, x+y_centre, nColor );
PutPixelMode1( x+x_centre, -y+y_centre, nColor );
PutPixelMode1( y+x_centre, -x+y_centre, nColor );
PutPixelMode1( -x+x_centre, -y+y_centre, nColor );
PutPixelMode1( -y+x_centre, -x+y_centre, nColor );
if ( d >= 2*(x-1) )
{
d = d - (2*x);
x = x + 1;
}
else if ( d <= 2*(x-y) )
{
d = d + (2*y) - 1;
y = y-1;
}
else
{
d = d + 2*(y-x-1);
y = y-1;
x = x+1;
}
}

}

void lineBresenham2(int x1,int y1,int x2,int y2) {
int cx, cy,
ix, iy,
dx, dy,
ddx= x2-x1, ddy= y2-y1;

if (!ddx) { //vertical line special case
if (ddy > 0) {
cy= y1;
do PutPixelFastMode1(x1, cy++);
while (cy <= y2);
return;
} else {
cy= y2;
do PutPixelFastMode1(x1, cy++);
while (cy <= y1);
return;
}
}
if (!ddy) { //horizontal line special case
if (ddx > 0) {
cx= x1;
do PutPixelFastMode1(cx, y1);
while (++cx <= x2);
return;
} else {
cx= x2;
do PutPixelFastMode1(cx, y1);
while (++cx <= x1);
return;
}
}
if (ddy < 0) { iy= -1; ddy= -ddy; }//pointing up
else iy= 1;
if (ddx < 0) { ix= -1; ddx= -ddx; }//pointing left
else ix= 1;
dx= dy= ddx*ddy;
cy= y1, cx= x1;
if (ddx < ddy) { // < 45 degrees, a tall line
do {
dx-=ddy;
do {
PutPixelFastMode1(cx, cy);
cy+=iy, dy-=ddx;
} while (dy >=dx);
cx+=ix;
} while (dx > 0);
} else { // >= 45 degrees, a wide line
do {
dy-=ddx;
do {
PutPixelFastMode1(cx, cy);
cx+=ix, dx-=ddy;
} while (dx >=dy);
cy+=iy;
} while (dy > 0);
}
}

void Circle2(int radius, int x_centre, int y_centre) {
int x =0;
unsigned char y = radius;
int d = radius - 1;
while ( y >= x )
{
PutPixelFastMode1( x+x_centre, y+y_centre  );
PutPixelFastMode1( y+x_centre, x+y_centre  );
PutPixelFastMode1( -x+x_centre, y+y_centre  );
PutPixelFastMode1( -y+x_centre, x+y_centre  );
PutPixelFastMode1( x+x_centre, -y+y_centre  );
PutPixelFastMode1( y+x_centre, -x+y_centre  );
PutPixelFastMode1( -x+x_centre, -y+y_centre  );
PutPixelFastMode1( -y+x_centre, -x+y_centre  );
if ( d >= 2*(x-1) )
{
d = d - (2*x);
x = x + 1;
}
else if ( d <= 2*(x-y) )
{
d = d + (2*y) - 1;
y = y-1;
}
else
{
d = d + 2*(y-x-1);
y = y-1;
x = x+1;
}
}

}

void Circle3(int radius, int x_centre, int y_centre, unsigned char nColor) {
int x =0;
unsigned char y = radius;
int d = radius - 1;
gpen(nColor);
while ( y >= x )
{
plot( x+x_centre, y+y_centre );
plot( y+x_centre, x+y_centre );
plot( -x+x_centre, y+y_centre );
plot( -y+x_centre, x+y_centre );
plot( x+x_centre, -y+y_centre );
plot( y+x_centre, -x+y_centre );
plot( -x+x_centre, -y+y_centre );
plot( -y+x_centre, -x+y_centre );
if ( d >= 2*(x-1) )
{
d = d - (2*x);
x = x + 1;
}
else if ( d <= 2*(x-y) )
{
d = d + (2*y) - 1;
y = y-1;
}
else
{
d = d + 2*(y-x-1);
y = y-1;
x = x+1;
}
}

}

void main() {
unsigned int i;
unsigned int nTimeStart = 0;
unsigned int nTime1 = 0;
unsigned int nTime2 = 0;
unsigned int nTime3 = 0;	

	
//SCR_SET_MODE 1
__asm

ld a,#1
call #0xBC0E

__endasm;

gotoxy(1,1); cputs("Firmware use");
nTimeStart = GetTime();

for(i=0; i<25; i++)
{
gpen(i%4);

plot(108+i,48*2+i); draw(211+i,48*2+i);

plot(211+i,48*2+i); draw(211+i,151*2+i);
plot(211+i,151*2+i); draw(108+i,151*2+i);
plot(108+i,151*2+i); draw(108+i,48*2+i);
}

for (i=0; i< 50; i++)
{
Circle3(60+i, 320, 200, i%4);
}

nTime1 = GetTime() - nTimeStart;

clrscr();
gotoxy(1,1); cputs("Normal Pixelset");
nTimeStart = GetTime();

for(i=0; i<25; i++)
{
lineBresenham(108+i,48+i, 211+i,48+i,i%4);
lineBresenham(211+i,48+i, 211+i,151+i,i%4);
lineBresenham(211+i,151+i, 108+i,151+i,i%4);
lineBresenham(108+i,151+i, 108+i,48+i,i%4);
}


for (i=0; i< 50; i+=2)
{
Circle(30+i, 160, 100, i%4);
}

nTime2 = GetTime() - nTimeStart;

clrscr();
gotoxy(1,1); 
cputs("Speed Pixelset");
nTimeStart = GetTime();

for(i=0; i<25; i++)
{
gpenMode1(i%4);
lineBresenham2(108+i,48+i, 211+i,48+i);
lineBresenham2(211+i,48+i, 211+i,151+i);
lineBresenham2(211+i,151+i, 108+i,151+i);
lineBresenham2(108+i,151+i, 108+i,48+i);
}

for (i=0; i< 50; i++)
{
gpenMode1(i%4);
Circle2(30+i, 160, 100);
}

nTime3 = GetTime() - nTimeStart;


//KM_WAIT_CHAR
__asm
call #0xBB06
__endasm;

clrscr();
gotoxy(1,1);printf("Time Runde1 : %d", nTime1);
gotoxy(1,2);printf("Time Runde2 : %d", nTime2);
gotoxy(1,3);printf("Time Runde3 : %d", nTime3);

char3=cgetc();

}