//*****************************************************************************/
// CONIO.S - Amstrad CPC version of the Contiki conio.h (derived from borland C)
// To use with the Small Devices C Compiler
//
// 2003 H. Hansen  This file is not debugged in any way!
//*****************************************************************************/

//SB OK
void clrscr (void);
// Clear the whole screen and put the cursor into the top left corner

//SB OK
unsigned char kbhit (void);
// Return true if there's a key waiting, return false if not

//SB OK
void gotox (unsigned char x);
// Set the cursor to the specified X position, leave the Y position untouched

//SB ok
void gotoy (unsigned char y);
// Set the cursor to the specified Y position, leave the X position untouched

// SB OK
void gotoxy (unsigned char x, unsigned char y);
// Set the cursor to the specified position

//SB OK
unsigned char wherex (void);
// Return the X position of the cursor

//SB OK
unsigned char wherey (void);
// Return the Y position of the cursor

//SB OK
void cputc (char c);
// Output one character at the current cursor position

// SB OK
void cputs (const char* s);
// Output a NUL terminated string at the current cursor position

int cprintf (const char* format, ...);
// Like printf, but uses direct screen I/O

//int vcprintf (const char* format, va_list ap);
// Like vprintf, but uses direct screen I/O

//SB OK
char cgetc (void);
// Return a character from the keyboard. If there is no character available,
// the functions waits until the user does press a key. If cursor is set to
// 1 (see below), a blinking cursor is displayed while waiting.

//SB OK
unsigned char revers (unsigned char onoff);
// Enable/disable reverse character display. This may not be supported by
// the output device. Return the old setting.

//SB OK
unsigned char textcolor (unsigned char color);
// Set the color for text output. The old color setting is returned.

//SB Ok
unsigned char bgcolor (unsigned char color);
// Set the color for the background. The old color setting is returned. */

//SB Ok
unsigned char bordercolor (unsigned char color);
// Set the color for the border. The old color setting is returned.


